wayland::server::output_t(3)

NAME
wayland::server::output_t - compositor output region

SYNOPSIS

#include <wayland-server-protocol.hpp>

  Public Member Functions

std::function< void()> & on_release ()
release the output object
void geometry (int32_t x, int32_t y, int32_t physical_width, int32_t physical_height, output_subpixel const &subpixel, std::string const &make, std::string const &model, output_transform const &transform, bool post=true)
properties of the output
void mode (output_mode const &flags, int32_t width, int32_t height, int32_t refresh, bool post=true)
advertise available modes for the output
void done (bool post=true)
sent all information about output
bool can_done () const
Check whether the done function is available with the currently bound version of the protocol.
void scale (int32_t factor, bool post=true)
output scaling properties
bool can_scale () const
Check whether the scale function is available with the currently bound version of the protocol.
void name (std::string const &name, bool post=true)
name of this output
bool can_name () const
Check whether the name function is available with the currently bound version of the protocol.
void description (std::string const &description, bool post=true)
human-readable description of this output
bool can_description () const
Check whether the description function is available with the currently bound version of the protocol.
bool proxy_has_object () const
Check whether this wrapper actually wraps an object.
void post_no_memory () const
uint32_t get_id () const
client_t get_client () const
unsigned int get_version () const
std::string get_class ()

  Static Public Attributes

static constexpr std::uint32_t geometry_since_version = 1
Minimum protocol version required for the geometry function.
static constexpr std::uint32_t mode_since_version = 1
Minimum protocol version required for the mode function.
static constexpr std::uint32_t done_since_version = 2
Minimum protocol version required for the done function.
static constexpr std::uint32_t scale_since_version = 2
Minimum protocol version required for the scale function.
static constexpr std::uint32_t name_since_version = 4
Minimum protocol version required for the name function.
static constexpr std::uint32_t description_since_version = 4
Minimum protocol version required for the description function.

Detailed Description

compositor output region

An output describes part of the compositor geometry. The compositor works in the 'compositor coordinate system' and an output corresponds to a rectangular area in that space that is actually visible. This typically corresponds to a monitor that displays part of the compositor space. This object is published as global during start up, or when a monitor is hotplugged.

Definition at line 3706 of file wayland-server-protocol.hpp.

Member Function Documentation

  bool output_t::can_description () const

Check whether the description function is available with the currently bound version of the protocol.

Definition at line 2993 of file wayland-server-protocol.cpp.

  bool output_t::can_done () const

Check whether the done function is available with the currently bound version of the protocol.

Definition at line 2963 of file wayland-server-protocol.cpp.

  bool output_t::can_name () const

Check whether the name function is available with the currently bound version of the protocol.

Definition at line 2983 of file wayland-server-protocol.cpp.

  bool output_t::can_scale () const

Check whether the scale function is available with the currently bound version of the protocol.

Definition at line 2973 of file wayland-server-protocol.cpp.

  void output_t::description (std::string const & description, bool post = true)

human-readable description of this output

Parameters
    description output description

Many compositors can produce human-readable descriptions of their outputs. The client may wish to know this description as well, e.g. for output selection purposes.

The description is a UTF-8 string with no convention defined for its contents. The description is not guaranteed to be unique among all wl_output globals. Examples might include 'Foocorp 11" Display' or 'Virtual X11 output via :1'.

The description event is sent after binding the output object and whenever the description changes. The description is optional, and may not be sent at all.

The description event will be followed by a done event.

Definition at line 2988 of file wayland-server-protocol.cpp.

  void output_t::done (bool post = true)

sent all information about output This event is sent after all other properties have been sent after binding to the output object and after any other property changes done after that. This allows changes to the output properties to be seen as atomic, even if they happen via multiple events.

Definition at line 2958 of file wayland-server-protocol.cpp.

  void output_t::geometry (int32_t x, int32_t y, int32_t physical_width, int32_t physical_height, output_subpixel const & subpixel, std::string const & make, std::string const & model, output_transform const & transform, bool post = true)

properties of the output

Parameters
    x x position within the global compositor space
    y y position within the global compositor space
    physical_width width in millimeters of the output
    physical_height height in millimeters of the output
    subpixel subpixel orientation of the output
    make textual description of the manufacturer
    model textual description of the model
    transform transform that maps framebuffer to output

The geometry event describes geometric properties of the output. The event is sent when binding to the output object and whenever any of the properties change.

The physical size can be set to zero if it doesn't make sense for this output (e.g. for projectors or virtual outputs).

The geometry event will be followed by a done event (starting from version 2).

Note: wl_output only advertises partial information about the output position and identification. Some compositors, for instance those not implementing a desktop-style output layout or those exposing virtual outputs, might fake this information. Instead of using x and y, clients should use xdg_output.logical_position. Instead of using make and model, clients should use name and description.

Definition at line 2948 of file wayland-server-protocol.cpp.

  std::string wayland::server::resource_t::get_class () [inherited]
Retrieve the interface name (class) of a resource object.

Returns
    Interface name of the resource object.

  client_t wayland::server::resource_t::get_client () const [inherited]
Get the associated client

Returns
    the client that owns the resource.

  uint32_t wayland::server::resource_t::get_id () const [inherited]
Get the internal ID of the resource

Returns
    the internal ID of the resource

  unsigned int wayland::server::resource_t::get_version () const [inherited]
Get interface version

Returns
    Interface version this resource has been constructed with.

  void output_t::mode (output_mode const & flags, int32_t width, int32_t height, int32_t refresh, bool post = true)

advertise available modes for the output

Parameters
    flags bitfield of mode flags
    width width of the mode in hardware units
    height height of the mode in hardware units
    refresh vertical refresh rate in mHz

The mode event describes an available mode for the output.

The event is sent when binding to the output object and there will always be one mode, the current mode. The event is sent again if an output changes mode, for the mode that is now current. In other words, the current mode is always the last mode that was received with the current flag set.

Non-current modes are deprecated. A compositor can decide to only advertise the current mode and never send other modes. Clients should not rely on non-current modes.

The size of a mode is given in physical hardware units of the output device. This is not necessarily the same as the output size in the global compositor space. For instance, the output may be scaled, as described in wl_output.scale, or transformed, as described in wl_output.transform. Clients willing to retrieve the output size in the global compositor space should use xdg_output.logical_size instead.

The vertical refresh rate can be set to zero if it doesn't make sense for this output (e.g. for virtual outputs).

The mode event will be followed by a done event (starting from version 2).

Clients should not use the refresh rate to schedule frames. Instead, they should use the wl_surface.frame event or the presentation-time protocol.

Note: this information is not always meaningful for all outputs. Some compositors, such as those exposing virtual outputs, might fake the refresh rate or the size.

Definition at line 2953 of file wayland-server-protocol.cpp.

  void output_t::name (std::string const & name, bool post = true)

name of this output

Parameters
    name output name

Many compositors will assign user-friendly names to their outputs, show them to the user, allow the user to refer to an output, etc. The client may wish to know this name as well to offer the user similar behaviors.

The name is a UTF-8 string with no convention defined for its contents. Each name is unique among all wl_output globals. The name is only guaranteed to be unique for the compositor instance.

The same output name is used for all clients for a given wl_output global. Thus, the name can be shared across processes to refer to a specific wl_output global.

The name is not guaranteed to be persistent across sessions, thus cannot be used to reliably identify an output in e.g. configuration files.

Examples of names include 'HDMI-A-1', 'WL-1', 'X11-1', etc. However, do not assume that the name is a reflection of an underlying DRM connector, X11 connection, etc.

The name event is sent after binding the output object. This event is only sent once per output object, and the name does not change over the lifetime of the wl_output global.

Compositors may re-use the same output name if the wl_output global is destroyed and re-created later. Compositors should avoid re-using the same name if possible.

The name event will be followed by a done event.

Definition at line 2978 of file wayland-server-protocol.cpp.

  std::function< void()> & output_t::on_release ()

release the output object Using this request a client can tell the server that it is not going to use the output object anymore.

Definition at line 2942 of file wayland-server-protocol.cpp.

  void wayland::server::resource_t::post_no_memory () const [inherited]
Post "not enough memory" error to the client

If the compositor has not enough memory to fulfill a certail request of the client, this function can be called to notify the client of this circumstance.

  bool wayland::server::resource_t::proxy_has_object () const [inherited]

Check whether this wrapper actually wraps an object.

Returns
    true if there is an underlying object, false if this wrapper is empty

  void output_t::scale (int32_t factor, bool post = true)

output scaling properties

Parameters
    factor scaling factor of output

This event contains scaling geometry information that is not in the geometry event. It may be sent after binding the output object or if the output scale changes later. If it is not sent, the client should assume a scale of 1.

A scale larger than 1 means that the compositor will automatically scale surface buffers by this amount when rendering. This is used for very high resolution displays where applications rendering at the native resolution would be too small to be legible.

It is intended that scaling aware clients track the current output of a surface, and if it is on a scaled output it should use wl_surface.set_buffer_scale with the scale of the output. That way the compositor can avoid scaling the surface, and the client can supply a higher detail image.

The scale event will be followed by a done event.

Definition at line 2968 of file wayland-server-protocol.cpp.

Member Data Documentation

  std::uint32_t wayland::server::output_t::description_since_version = 4 [static], [constexpr]

Minimum protocol version required for the description function.

Definition at line 3944 of file wayland-server-protocol.hpp.

  std::uint32_t wayland::server::output_t::done_since_version = 2 [static], [constexpr]

Minimum protocol version required for the done function.

Definition at line 3834 of file wayland-server-protocol.hpp.

  std::uint32_t wayland::server::output_t::geometry_since_version = 1 [static], [constexpr]

Minimum protocol version required for the geometry function.

Definition at line 3772 of file wayland-server-protocol.hpp.

  std::uint32_t wayland::server::output_t::mode_since_version = 1 [static], [constexpr]

Minimum protocol version required for the mode function.

Definition at line 3819 of file wayland-server-protocol.hpp.

  std::uint32_t wayland::server::output_t::name_since_version = 4 [static], [constexpr]

Minimum protocol version required for the name function.

Definition at line 3914 of file wayland-server-protocol.hpp.

  std::uint32_t wayland::server::output_t::scale_since_version = 2 [static], [constexpr]

Minimum protocol version required for the scale function.

Definition at line 3870 of file wayland-server-protocol.hpp.

Author

Generated automatically by Doxygen for Wayland++ from the source code.